"""
 Conversion between coordinates systems
"""
import numpy as np


def cartesian_to_spherical(x, y, z):
    radius = np.sqrt(x**2 + y**2 + z**2)
    elevation = np.arctan2(z, np.sqrt(x**2 + y**2))
    azimuth = np.arctan2(y, x)
    spherical = np.zeros_like(x)
    spherical = np.tile(spherical[..., np.newaxis], (3,))
    return elevation, azimuth, radius


def spherical_to_cartesian(elevation, azimuth, radius=1):
    cartesian = np.zeros_like(elevation)
    cartesian = np.tile(cartesian[..., np.newaxis], (3,))
    x = np.cos(elevation) * np.cos(azimuth)
    y = np.cos(elevation) * np.sin(azimuth)
    z = np.sin(elevation)
    cartesian = radius * cartesian
    return x, y, z
